#!/usr/bin/perl

use strict;

if (@ARGV != 1) {
    print  "$0 output.pdf\n";
    exit;
}

my $outputfile=shift @ARGV;
if ($outputfile =~ /^--?h/) {
    print "$0 outputfilename.pdf\n\n";
    print "make_pdf.pl reads your default keyring, and calls 'sig2dot.pl', \n"
	. "'springgraph.pl', and 'ps2pdf' to create a PDF of a graph.\n";
    exit;
}

if ($outputfile !~ /\.pdf$/i) {
    $outputfile.=".pdf";
}

my $tmpps="/tmp/$$-tmp.ps";
system ("gpg --list-sigs | ./sig2dot.pl | ./springgraph.pl --scale 2.0 --output=$tmpps");

open(PS, $tmpps) || die "can't open $tmpps: $!";

# get the postscript BoundingBox so we can force the PDF to use the same
# geometry
my $geom;
while(<PS>) {
    if (m@%%BoundingBox.*\s(\d+)(\.?\d*)\s+(\d+)(\.?\d*)$@) {
	my ($width, $height)=($1,$3);
	if ($2) {$width++}
	if ($4) {$height++}
	$geom=$width ."x" . $height;
	last;
    }
}
close PS;

system('ps2pdf', '-r72', "-g$geom", $tmpps, $outputfile);
unlink($tmpps);

